<?php
/**************************************************
  Coppermine Plugin - Delete Control
  *************************************************
  Copyright (c) 2005 Paul Van Rompay
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
***************************************************/
//
if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

// ------------------------------------------------------------------------------------------------
// Add filters - process search album and add to search results page
// ------------------------------------------------------------------------------------------------
$thisplugin->add_filter('page_html','delcon_filterpage');

// ------------------------------------------------------------------------------------------------
// Add actions
// ------------------------------------------------------------------------------------------------
$thisplugin->add_action('page_start','delcon_restrictaccess');

// ------------------------------------------------------------------------------------------------
// Filter page_html to remove delete buttons
// ------------------------------------------------------------------------------------------------
//
  function delcon_filterpage($html) {
  	if (defined('DISPLAYIMAGE_PHP') && !GALLERY_ADMIN_MODE) {
//  		$html = preg_replace('/<a href="delete\.php.*?<\/a>/','',$html);
		$html = preg_replace('/<li>[^<]*<a href="delete\.php.*?<\/a>[^<]*<\/li>/i','',$html);
  	}

//V1.041Original statement
//	if (defined('INDEX_PHP') && !GALLERY_ADMIN_MODE) {
//		$html = preg_replace('/(?U)<td.*\s*<a href="delete\.php(?s).*<\/a>.*<\/td>/','',$html);
//	}
//V1.041Modified preg replace to take into account li tags
	if (defined('INDEX_PHP') && !GALLERY_ADMIN_MODE) {
		$html = preg_replace('/<li>[^<]*<a href="delete\.php[^<]*<span>[^<]*<\/span><\/a>[^<]*<\/li>/i','',$html);
	}

//V1.041New preg_replace statement.
	if (defined('EDITPICS_PHP') && !GALLERY_ADMIN_MODE) {
//		$html = preg_replace('/(?U)<td.*\s*<span.*\s*.*(?s)name="deleteAll".*<\/td>/','',$html);
//		$html = preg_replace('/(?U)<td.*(?s)name="delete\d+".*<\/td>/','',$html);
		$html = preg_replace('/<td class="(tableh2|tableb|tableb tableb_alternate)" width="40" valign="top">.*name="delete.*".*<\/td>/Us','',$html);
	}

//V1.041New preg_replace statement.
	if (defined('ALBMGR_PHP') && !GALLERY_ADMIN_MODE) {
//		$html = preg_replace('/(?U)<td.*\s*(?s)javascript:Album_Delete().*<\/td>/','<td width="80">&nbsp;</td>',$html);
		$html = preg_replace('/<button type="button" id="delete_album".*<\/button>/U','',$html);
	}
	return $html;
}

// ------------------------------------------------------------------------------------------------
// Restrict access to delete.php script
// ------------------------------------------------------------------------------------------------
function delcon_restrictaccess() {
	global $lang_errors, $lang_error;
  	if (defined('DELETE_PHP') && !GALLERY_ADMIN_MODE) {
  		$try_to_delete = false;
//V1.04Comment out original line as follows:
// 		$what = isset($_GET['what']) ? $_GET['what'] : $_POST['what'];
//V1.04 Replace with Andre recommended 1.5 code
                $superCage = Inspekt::makeSuperCage();
                if ($superCage->get->keyExists('what')) {
                    $what = $superCage->get->getAlpha('what');
                } elseif ($superCage->post->keyExists('what')) {
                    $what = $superCage->post->getAlpha('what');
                } else {
                    cpg_die(CRITICAL_ERROR, $lang_errors['param_missing'], __FILE__, __LINE__);
                }
//V1.04 Replace end

//V1.041Comment out original line as follows:
//  		if (($what != 'albmgr') || (($what == 'albmgr') && $_POST['delete_album'])) {
//V1.041 Replace with Andre recommended 1.5 code
  		if (($what != 'albmgr') || (($what == 'albmgr') && $superCage->post->keyExists('delete_album'))) {

  			$try_to_delete = true;
  		}
  		if ($try_to_delete) {
  			load_template();
  			pageheader($lang_error);
  			cpg_die(ERROR, $lang_errors['perm_denied'], __FILE__, __LINE__);
  		}
  	}
	if (defined('EDITPICS_PHP') && !GALLERY_ADMIN_MODE) {

		$try_to_delete = false;
//V1.041 Mod following Line
//	        $pid_array = $_POST['pid'];

		$superCage = Inspekt::makeSuperCage();
		$pid_array = $superCage->post->getInt('pid');
	        foreach($pid_array as $pid){
        	        $pid = (int)$pid;
//V1.041 Mod following line
//			if (isset($_POST['delete'.$pid])) $try_to_delete = true;
 			if ($superCage->post->keyExists('delete'.$pid)) $try_to_delete = true;
		}
		if ($try_to_delete) {
			load_template();
			pageheader($lang_error);
			cpg_die(ERROR, $lang_errors['perm_denied'], __FILE__, __LINE__);
		}
	}
}

// ------------------------------------------------------------------------------------------------
// End of plugin code
// ------------------------------------------------------------------------------------------------

?>
